from typing import Iterable

from v6d2ctx.context import Context, Implicit


async def catch(ctx: Context, args: list[str], reply: str, *catched: (Iterable[str] | str), attachments_ok=True):
    if ctx.message.attachments and attachments_ok:
        return
    real_catched = {(case,) if isinstance(case, str) else tuple(case) for case in catched}
    if tuple(args) in real_catched:
        await ctx.reply(reply.strip())
        raise Implicit
